    001/* ===========================================================
    002 * JFreeChart : a free chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jfreechart/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025 * Other names may be trademarks of their respective owners.]
    026 *
    027 * ----------------
    028 * KeyedValues.java
    029 * ----------------
    030 * (C) Copyright 2002-2008, by Object Refinery Limited.
    031 *
    032 * Original Author:  David Gilbert (for Object Refinery Limited);
    033 * Contributor(s):   -;
    034 *
    035 * Changes:
    036 * --------
    037 * 23-Oct-2002 : Version 1 (DG);
    038 * 12-Jan-2005 : Updated Javadocs to specify new behaviour when key
    039 *               is not recognised (DG);
    040 * ------------- JFREECHART 1.0.0 ---------------------------------------------
    041 * 02-May-2006 : Updated API docs (DG);
    042 *
    043 */
    044
    045package org.jfree.data;
    046
    047import java.util.List;
    048
    049/**
    050 * An ordered list of (key, value) items where the keys are unique and
    051 * non-<code>null</code>.
    052 *
    053 * @see Values
    054 * @see DefaultKeyedValues
    055 */
    056public interface KeyedValues extends Values {
    057
    058    /**
    059     * Returns the key associated with the item at a given position.  Note
    060     * that some implementations allow re-ordering of the data items, so the
    061     * result may be transient.
    062     *
    063     * @param index  the item index (in the range <code>0</code> to
    064     *     <code>getItemCount() - 1</code>).
    065     *
    066     * @return The key (never <code>null</code>).
    067     *
    068     * @throws IndexOutOfBoundsException if <code>index</code> is not in the
    069     *     specified range.
    070     */
    071    public Comparable getKey(int index);
    072
    073    /**
    074     * Returns the index for a given key.
    075     *
    076     * @param key  the key (<code>null</code> not permitted).
    077     *
    078     * @return The index, or <code>-1</code> if the key is unrecognised.
    079     *
    080     * @throws IllegalArgumentException if <code>key</code> is
    081     *     <code>null</code>.
    082     */
    083    public int getIndex(Comparable key);
    084
    085    /**
    086     * Returns the keys for the values in the collection.  Note that you can
    087     * access the values in this collection by key or by index.  For this
    088     * reason, the key order is important - this method should return the keys
    089     * in order.  The returned list may be unmodifiable.
    090     *
    091     * @return The keys (never <code>null</code>).
    092     */
    093    public List getKeys();
    094
    095    /**
    096     * Returns the value for a given key.
    097     *
    098     * @param key  the key.
    099     *
    100     * @return The value (possibly <code>null</code>).
    101     *
    102     * @throws UnknownKeyException if the key is not recognised.
    103     */
    104    public Number getValue(Comparable key);
    105
    106}